mode(-1);
// ----------------------------------------------------------------------
// Build sciFLT toolbox
// ----------------------------------------------------------------------
// This file is part of sciFLT ( Scilab Fuzzy Logic Toolbox )
// Copyright (C) 2004 Jaime Urzua Grez
// mailto:jaime_urzua@yahoo.com
// Toolbox Revision 0.2 -- 2004/10/12
// ----------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// ----------------------------------------------------------------------
// NOTES:
// (1) I try to build sciFLT under Windows using lcc but :
//     - The translation from fortran to C don't work automatically.
//     - If I translate by hand using command line, the resulting
//       code hang scilab ... why?
//     - Finally, the unstable version (september 2004) lcc don't work!
// ----------------------------------------------------------------------
// Changes:
// 2004-10-06 Change LCC detection, fix bug in help pages, add information
//            in loader


if with_tk() then
	// SOME INTERNAL DECLARATIONS
	build_man=%t;
	build_lib=%t;
	change_path=%t;

	// GET FILEPATH
	lines(0);
	FLT_PATH=get_file_path('builder.sce');
	CURDIR=pwd();
	chdir(FLT_PATH);

	// GENERATE LIBRARY
	write(%io(2)," (1) Building library (scilab objects).");
	genlib('sciFLT',FLT_PATH+"macros",%t);

	// BUILD CODE
	if (build_lib) then
		if (with_lcc()) then
			write(%io(2)," The compiler is LCC. I can't build. See notes in builder.sce");
		else
			write(%io(2)," (2) Building library (compliled objects).");
			exec(FLT_PATH+"src/builder.sce");
		end
	end

	// GENERATE LOADER.SCE
	write(%io(2)," (3) Building loader.sce .");
	txt=["mode(-1)";"// sciFLT LOADER PLEASE DO NOT EDIT!"]
	txt=[txt;"FLT_PATH=get_file_path(''loader.sce'')"];
	txt=[txt;"curdir=pwd();"];
	txt=[txt;"load(FLT_PATH+""macros/lib"");"];
	txt=[txt;"exec(FLT_PATH+""src/loader.sce"");"];
	txt=[txt;"scicos_pal=[scicos_pal; ""Fuzzy Logic"" FLT_PATH+""Fuzzy_Logic.cosf""];"];
	txt=[txt;"chdir(curdir);"];
	txt=[txt;"TK_SetVar(""sciFLTpath"",strsubst(FLT_PATH,""\"",""/""));"];
	txt=[txt;"TK_SetVar(""sciFLTpath_temp"",strsubst(TMPDIR,""\"",""/""))"];
	txt=[txt;"TK_EvalFile(FLT_PATH+""gui/plotsurf.tcl"");"];
	txt=[txt;"TK_EvalFile(FLT_PATH+""gui/demos_examples.tcl"");"];
	txt=[txt;"TK_EvalFile(FLT_PATH+""gui/scicos_param.tcl"");"];
	txt=[txt;"TK_EvalFile(FLT_PATH+""gui/fuzzy_editor.tcl"");"];
	txt=[txt;"add_help_chapter(""Fuzzy Logic"",FLT_PATH+""man/eng"");"]
	txt=[txt;"clear FLT_PATH curdir EEP functions libsciFLT_path ;"];
	txt=[txt;"write(%io(2),""sciFLT loaded !. Try sciFLTdemo to see demos and examples."");"];
	mputl(txt,FLT_PATH+"loader.sce");

	// BUILD DOCUMENTATION
	if (build_man) then
		write(%io(2)," (4) Building documentation .");
		txt=mgetl(SCI+"/man/manrev.dtd");
		mputl(txt,FLT_PATH+"man/eng/manrev.dtd");
		chdir(FLT_PATH+"man/eng");
		xmltohtml(FLT_PATH+"man/eng","Fuzzy Logic",'html-rev.xsl')
		chdir(FLT_PATH+"man/eng");
		write(%io(2),"     Fixing images in help pages.");
		// FIX IMAGES
		if MSDOS then
			fq=unix_g("dir /b *.htm");
		else
			fq=unix_g("ls *.htm");
		end
		for j=1:size(fq,"*"),			
			txt=mgetl(fq(j));
			if (change_path) then
				txt=strsubst(txt,"../","");
				txt=strsubst(txt,"./","");
			end
			txt=strsubst(txt,"@SCIFLT@","<img src=""logo.gif""></img>");
			txt=strsubst(txt,"<p>IMAGEN</p>","<p><img src="""+fileparts(fq(j),'fname')+".gif""></img></p>");
			mputl(txt,fq(j));
		end
	end

	clear build_man build_lib change_path;

	// AUTOLOAD
	write(%io(2)," (5) Loading toolbox .");
	exec(FLT_PATH+"loader.sce");

	// ALL DONE !
	write(%io(2)," (6) SCIFLT NOW ARE READY TO USE TRY sciFLTdemo() .");
	chdir(CURDIR);
	TK_EvalFile(flt_path()+"gui/readme.tcl");

else
	error("sciFLT need TK/TCL!");
end

