# ----------------------------------------------------------------------
# SHOW README FILE DURING INSTALL
# ----------------------------------------------------------------------
# This file is part of sciFLT ( Scilab Fuzzy Logic Toolbox )
# Copyright (C) 2004 Jaime Urzua Grez
# mailto:jaime_urzua@yahoo.com
# Toolbox Revision 0.2 -- 2004/10/12
# ----------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# ----------------------------------------------------------------------

proc sciFLTReadme { dir1 } {
	image create photo logo_flt -file [file join $dir1 "data" "logo.gif"]
	set w ".sciFLTReadme"
	catch { destroy $w }
	toplevel $w
	wm geometry $w 400x300
	wm resizable $w 0 1
	wm title $w "sciFLT toolbox"	
	frame $w.top -bd 3 -background white -relief groove
	label $w.top.mes01 -text "Some about ..." -bg white -font {-*-helvetica-bold-r-*-*-24}
	label $w.top.logo -image logo_flt -bg white
	pack $w.top.logo -expand 1 -fill x -side left
	pack $w.top.mes01 -expand 1 -fill x -side right
	frame $w.center
	text $w.center.txt -wrap word -width 1 -height 1  -yscrollcommand "$w.center.sby set"
	$w.center.txt tag configure t0 -foreground black 
	$w.center.txt tag configure t1 -foreground blue -font {-*-helvetica-bold-r-*-*-16} -justify center
	$w.center.txt tag configure t2 -foreground navy
	set tc t0
	scrollbar $w.center.sby -orient vertical -command "$w.center.txt yview"
	pack $w.center.txt -side left -fill both -expand 1
	pack $w.center.sby -side left -fill both -expand 0
	set fid [open [file join $dir1 "../readme.txt" ] r]
	while { [eof $fid]==0 } {
		gets $fid lineRead
		if { [string range $lineRead 0 0]=="*" } then {
			$w.center.txt insert end "[string range $lineRead 1 end]\n" t1
		} elseif  { [string range $lineRead 0 8]=="Copyright" } then {
			set tc t2
			$w.center.txt insert end "$lineRead\n" $tc
		} else {		
			$w.center.txt insert end "$lineRead\n" $tc
		}
	}
	close $fid
	frame $w.bottom
	button $w.bottom.exit -text "quit" -command "destroy $w"
	pack $w.bottom.exit -fill both -expand 1
	pack $w.top    -side top -expand 0 -fill both
	pack $w.center -side top -expand 1 -fill both
	pack $w.bottom -side top -expand 0 -fill both -padx 3 -pady 3
}

sciFLTReadme "[file dirname [info script]]"
