function [x,y,typ]=scicos_fls(job,arg1,arg2)
// ----------------------------------------------------------------------
// FLS SCICOS INTERFACE BLOCK
// ----------------------------------------------------------------------
// This file is part of sciFLT ( Scilab Fuzzy Logic Toolbox )
// Copyright (C) 2004 Jaime Urzua Grez
// mailto:jaime_urzua@yahoo.com
// Toolbox Revision 0.2 -- 2004/10/12
// ----------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// ----------------------------------------------------------------------

x=[];y=[];typ=[];

select job
case 'plot' then
	standard_draw(arg1);
case 'getinputs' then
	[x,y,typ]=standard_inputs(arg1);
case 'getoutputs' then
	[x,y,typ]=standard_outputs(arg1);
case 'getorigin' then
	[x,y]=standard_origin(arg1);
case 'set' then
	// SET VALUE
	x=arg1;
	[ok,par,typ]=scicos_sp(200,x.graphics.exprs);
	if (ok==1) then
		x.model.ipar=par(1);
		x.model.rpar=par(2);		
		x.graphics.exprs=par(3);
		x.model.in=x.model.ipar(2);
		x.model.out=x.model.ipar(3);		
	end
case 'define' then
	// DEFINITION
	model=scicos_model();
	model.sim=list('sfls',1001); 
	model.in=-1;
	model.out=1;
	model.ipar=0;
	model.rpar=[];
	model.blocktype='c';
	model.dep_ut=[%t %f];
	gr_i='scicos_icons(200,sz,orig);';
	x=standard_define([2 2],model,[],gr_i)
end
endfunction

