function [x,y,typ]=scicos_mf(job,arg1,arg2)
// ----------------------------------------------------------------------
// MEMBER FUNCTION SCICOS INTERFACE BLOCK
// ----------------------------------------------------------------------
// This file is part of sciFLT ( Scilab Fuzzy Logic Toolbox )
// Copyright (C) 2004 Jaime Urzua Grez
// mailto:jaime_urzua@yahoo.com
// Toolbox Revision 0.2 -- 2004/10/12
// ----------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// ----------------------------------------------------------------------

x=[];y=[];typ=[];

select job
case 'plot' then
	standard_draw(arg1);
case 'getinputs' then
	[x,y,typ]=standard_inputs(arg1);
case 'getoutputs' then
	[x,y,typ]=standard_outputs(arg1);
case 'getorigin' then
	[x,y]=standard_origin(arg1);
case 'set' then
	// SET VALUE
	x=arg1;	
	[ok,par,typ]=scicos_sp(x.model.ipar(1),x.model.rpar);
	if (ok==1) then
		x.model.ipar=typ;
		x.model.rpar=par(:);
	end	
case 'define' then
	// DEFINITION
	model=scicos_model();
	model.sim=list('smfeval',1001); 
	model.in=-1;
	model.out=-1;
	// SET AS NONE
	model.ipar=0;
	model.rpar=[];
	model.blocktype='c';
	model.dep_ut=[%t %f];	
	gr_i='scicos_icons(model.ipar(1),sz,orig);';
	x=standard_define([2 2],model,[],gr_i)
end
endfunction

