mode(-1);
// ----------------------------------------------------------------------
// BUILD SOURCE C/FORTRAN CODE
// ----------------------------------------------------------------------
// This file is part of sciFLT ( Scilab Fuzzy Logic Toolbox )
// Copyright (C) 2004 Jaime Urzua Grez
// mailto:jaime_urzua@yahoo.com
// Toolbox Revision 0.2 -- 2004/10/12
// ----------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// ----------------------------------------------------------------------
// NOTES:
// (1) SEE builder.sce in ../
// ----------------------------------------------------------------------

// CHANGE TO DIR
curdir=pwd();
libsciFLT_path=get_file_path('builder.sce');
chdir(libsciFLT_path);

// LIBRARY NAME
ilib_name="libsciFLT";

// TABLE OF CALLING
table=[
	"trimf","inter_anymf";
	"trapmf","inter_anymf";
	"gaussmf","inter_anymf";
	"gauss2mf","inter_anymf";
	"sigmf","inter_anymf";
	"psigmf","inter_anymf";
	"dsigmf","inter_anymf";
	"gbellmf","inter_anymf";
	"smf","inter_anymf";
	"zmf","inter_anymf";
	"pimf","inter_anymf";
	"constant","inter_anymf";
	"linear","inter_anymf";
	"mfeval","inter_mfeval";
	"complement","inter_complement";
	"snorm","inter_snorm";
	"tnorm","inter_tnorm";
	"defuzzm","inter_defuzzm";
	"flsencode","inter_flsencode";
	"evalfls","inter_evalfls";
];

// EXTRA ENTRY POINTS -> SCICOS
EEP=[
	"smfeval";
	"stnorm";
	"ssnorm";
	"scomplement";
	"sfls";
];

// FILES TO COMPILE
files=[
	"complement";
	"defuzzm";
	"flsencode";
	"flsengine";
	"inter_sciFLT";
	"mfs";
	"snorm";
	"tnorm";
	"util1";
	"util2";
	"sfls";
];

// EXTRA LIBRARY
libs=[];

// BUILD
if (with_lcc()) then
	// WITH LCC I HAVE SOME PROBLEMS!
	disp("HEY WITH LCC ! -> I CAN''T WORK!");
else	
	ilib_build(ilib_name,table,files,libs);
	write(%io(2)," Fixing loader -> scicos blocks");
	if getenv('WIN32','NO')=='OK' then
		lib_suf='dll';
	else
		lib_suf=ilib_unix_soname();
	end
	[fd,er]=mopen("loader.sce","a");
	mfprintf(fd,"EEP=[\n");
	for nn=EEP,
		mfprintf(fd," ""%s"";\n",nn);	
	end
	mfprintf(fd,"];\n");
	mfprintf(fd,"link(%s_path+''/%s.%s'',EEP);\n",ilib_name,ilib_name,lib_suf);
	mclose(fd);
	
end

chdir(curdir);
