/* -----------------------------------------------------------------------
 * SCICOS FLS COMPUTATION BLOCK
 * -----------------------------------------------------------------------
 * This file is part of sciFLT ( Scilab Fuzzy Logic Toolbox )
 * Copyright (C) 2004 Jaime Urzua Grez
 * mailto:jaime_urzua@yahoo.com
 * Toolbox Revision 0.2 -- 2004/10/12
 * -----------------------------------------------------------------------
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * -----------------------------------------------------------------------
 */

#include "stack-c.h"
#include "sciFLT.h"

int C2F(sfls)(flag, nevprt, t, xd, x, nx, z, nz, tvec, ntvec, rpar, nrpar, ipar, nipar, u, nu, y, ny)
     int *flag, *nevprt,*nx,*nz,*nrpar, *ipar, *nipar,*ntvec,*nu,*ny;
     double *t, *xd, *x, *z, *tvec, *rpar, *u, *y;
{
	int i,tofree[5],ierr,idx,one=1,ninputs,noutputs,nrules,ncolmparo;
	int *mrule,*mid1,*npev;
	double *mdomo,*mpari,*mparo,*mew,*mid2,*tmp1,*tmp2,tmp3,*tmp4;
	int maxnpev=1001;

	/* DUMMY OUTPUT */
	for (i=0;i<*nu;++i) {y[i]=-1.0;}
	
	/* CHECK IF THE USER SELECT A FLS STRUCTURE */
	/* I REALLY LIKE SOME OTHER ERROR MESSAGE ! */	
	if ( ipar[0]!=1 ) { sciFLT_doerror(999); *flag=-30; goto goout;	}	
	
	/* GET INFORMATION */
	ninputs=ipar[1];
	noutputs=ipar[2];
	nrules=ipar[3];
	
	/* chek if are somethig to evaluate */
	if (ninputs*noutputs*nrules==0) { sciFLT_doerror(999); *flag=-30; goto goout; }	

	/* check the input size */
	if (ninputs!=*nu) { sciFLT_doerror(999); *flag=-30; goto goout; }	

	/* intiliaze */
	for (i=0;i<5;i++) { tofree[i]=0; }
	
	/* get the rest of integer parameters */
	idx=4;
	mrule=&ipar[idx];
	idx+=nrules*(ninputs+noutputs+1);
	mid1=&ipar[idx];
	
	/* get the ral values */
	idx=0;
	mdomo=&rpar[0];
	idx+=noutputs*2;
	mpari=&rpar[idx];
	idx+=4*ninputs*nrules;
	mparo=&rpar[idx];
	if (mid1[0]==0) {
		ncolmparo=4;
	} else {		
		ncolmparo=ninputs+1;
	}
	idx+=ncolmparo*noutputs*nrules;
	mew=&rpar[idx];
	idx+=nrules;
	mid2=&rpar[idx];

	tmp1=(double*)malloc(ninputs*sizeof(double));
	if (tmp1==NULL) { sciFLT_doerror(999); *flag=-30; goto goout; }
	tofree[0]=1;
	
	tmp2=(double*)malloc(nrules*sizeof(double));
	if (tmp2==NULL) { sciFLT_doerror(999); *flag=-30; goto goout; }
	tofree[1]=1;
	
	if ( mid1[0]==0 ) {
		npev=(int*)malloc(noutputs*sizeof(int));
		if (npev==NULL) { sciFLT_doerror(999); *flag=-30; goto goout; }
		tofree[4]=1;
		for (i=0;i<noutputs;i++) { npev[i]=maxnpev; }
		tmp4=(double*)malloc(maxnpev*3*sizeof(double));
		if (tmp4==NULL) { sciFLT_doerror(999); *flag=-30; goto goout; }
		tofree[3]=1;
	}

	// sciprint("ninputs=%d noutputs=%d\n",ninputs,noutputs);
	
	C2F(flsengine)(u,mid1,mid2,mew,mrule,mdomo,mpari,mparo,&ncolmparo,npev,&ninputs,&noutputs,&nrules,&one,tmp1,tmp2,&tmp3,tmp4,&maxnpev,y,&ierr);

	if (ierr!=0) {
		*flag=-1;
	}
			
goout:
	if (tofree[0]==1 ) { free(tmp1); }
	if (tofree[1]==1 ) { free(tmp2); }
	//if (tofree[2]==1 ) { free(tmp3); }
	if (tofree[3]==1 ) { free(tmp4); }
	if (tofree[4]==1 ) { free(npev); }

	return 0;
}

