c -----------------------------------------------------------------------
c UTILITY
c -----------------------------------------------------------------------
c This file is part of sciFLT ( Scilab Fuzzy Logic Toolbox )
c Copyright (C) 2004 Jaime Urzua Grez
c mailto:jaime_urzua@yahoo.com
c Toolbox Revision 0.2 -- 2004/10/12
c -----------------------------------------------------------------------
c This program is free software; you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation; either version 2 of the License, or
c (at your option) any later version.
c -----------------------------------------------------------------------

C --------------------------------------------------       
C      INITIALIZE SOME MATRIX TO VALUE
C --------------------------------------------------       
       subroutine inival(x,m,n,va)
       integer m,n
       double precision x(m,n),va

       integer i,j
       
       do 120, j=1, n
        do 110, i=1, m
         x(i,j)=va
110     continue
120    continue
         
       return
       end

C --------------------------------------------------       
C      INITIALIZE 1 column SOME MATRIX TO VALUE
C --------------------------------------------------       
       subroutine inival1c(c,x,m,n,va)
       integer m,n,c
       double precision x(m,n),va

       integer i
       do 200, i=1, m
        x(i,c)=va
200    continue

       return
       end
     
C --------------------------------------------------       
C INTEGER SIGN
C --------------------------------------------------
      function isgn(n)
      integer isgn,n
      if (n.gt.0) then
       isgn=1
      elseif (n.eq.0) then
       isgn=0
      else
       isgn=1
      endif
      return
      end

C --------------------------------------------------       
C GET MATRIX OF WEIGTHS
C --------------------------------------------------
       subroutine getmw(rule,nrules,ninputs,noutputs,mwe)
       integer nrules,ninputs,noutputs
       double precision rule(nrules,*),mwe(*)
       
       integer i,j

       j=ninputs+noutputs+2
       do 10, i=1, nrules
        mwe(i)=rule(i,j)
10     continue
       return
       end

C --------------------------------------------------       
C GET MATRIX OF RULES
C --------------------------------------------------
       subroutine getmr(rule,nrules,ninputs,noutputs,mrule)
       integer nrules,ninputs,noutputs
       double precision rule(nrules,*)
       integer mrule(nrules,*)
       
       integer i,j

       j=ninputs+noutputs+2
       do 30, j=1, ninputs+noutputs+1
        do 20, i=1, nrules
         mrule(i,j)=int(rule(i,j))
20      continue        
30     continue
       return
       end

C --------------------------------------------------       
C CREATE A LINEAR SPACE
C --------------------------------------------------
       subroutine dolinspa(minDom,maxDom,npart,x)
       integer npart
       double precision x(*),minDom,MaxDom
       
       integer i
       double precision dt

       dt=(maxDom-minDom)/(npart-1)
       do 40, i=1,npart
        x(i)=minDom+dt*(i-1)
40     continue
       return
       end

